#include "BlastDoor.h"
#include "Spaceman.h"
#include "PlayState.h"
#include "GGj2015.h"
#include "cmLocatorManager.h"

BlastDoor::BlastDoor(const std::string& locator, Player owner)
	: m_owner(owner)
{
	m_transform = cmLocatorManager::Get().GetLocator(locator);
	m_collision = new SphereCollision(this, 4.0f);
}

BlastDoor::~BlastDoor()
{}

void BlastDoor::OnCollision(Entity* pEntity) 
{
	Entity::OnCollision(pEntity);

	Spaceman* pSpaceman = dynamic_cast<Spaceman*>(pEntity);
	if (pSpaceman)
	{
		// Stage winner!
		if (m_state == Locked && pSpaceman->m_player == m_owner)
		{
			PlayState* pState = (PlayState*)GGJ2015::Get()->GetGameStateManager()->GetCurrentState();
			pState->SetPlayerStageWinner(m_owner);
			m_state = Open;
		}

		if (m_state == Open)
		{
			// Start taking any of the entites that collide with it and store them
			// preserve them for later
			m_transitioningSpacemen.push_back(pEntity->shared_from_this());
			GGJ2015::Get()->GetEntityManager()->RemoveEntity(pEntity);
		}
	}
}

void BlastDoor::Render()
{
	Entity::Render();
	// TODO:
	
}