#include "Camera.h"


Camera::Camera()
{
}

Camera::~Camera()
{
}

void Camera::Init()
{
	m_transform.position = Vector3(0.0f, 0.0f, 30.0f);
	m_transform.pitch(deg2rad(-90.0f));
	m_transform.roll(deg2rad(90.0f));
	//m_transform.lookAt(Vector3::zero());

	ResetMouse();
	m_fMoveTimer = 0;
	m_bZoom = false;
}

void Camera::Update()
{
	m_transform.position = Vector3(0.0f, 0.0f, 100.0f);
	
	float fZoomDiff = 0.0f;
	if (gPlatform->GetTouchPoints().size() == 1 && !m_bZoom)
	{
		Rotate(gPlatform->GetTouchPoints()[0]);
	}
	else if (gPlatform->IsMouseDown(MouseRight))
	{
		m_bZoom = true;
		m_fZoomDist = 10.0f;
		fZoomDiff = 10.0f;

		if (gPlatform->IsMouseDown(MouseLeft))
		{
			fZoomDiff *= -1;
		}
	}
	else if (gPlatform->IsMouseDown(MouseLeft))
	{
		Rotate(gPlatform->GetMousePos());
	}
	else if(gPlatform->GetTouchPoints().size() >= 2)
	{
		m_bZoom = true;
		float fDist = Vector3(gPlatform->GetTouchPoints()[0] - gPlatform->GetTouchPoints()[1]).magnitude();
		if(m_fZoomDist > 0)
		{
			fZoomDiff = fDist - m_fZoomDist;
		}
		m_fZoomDist = fDist;
	}
	else if(gPlatform->GetTouchPoints().size() == 0)
	{
		m_bZoom = false;
		m_fZoomDist = -1.0f;
	}
	else if(gPlatform->GetTouchPoints().size() == 1 && m_bZoom)
	{
		m_fZoomDist = -1.0f;
	}

	
	if(m_fZoomDist > 0)
	{
		m_transform.translateWorld(m_transform.forward * gPlatform->GetDeltaTime() * 0.02f * fZoomDiff / 3.0f);
	}

	m_vCamAngle.x = wrapFloat(m_vCamAngle.x + (float)TAU, (float)TAU);
	m_vCamAngle.y = clampFloat(m_vCamAngle.y, deg2rad(-80.0f), deg2rad(80.0f));
	//m_transform.lookAt(m_transform.position + Vector3::forward(), Vector3::up());
	//m_transform.yaw(-m_vCamAngle.x);
	//m_transform.pitch(-m_vCamAngle.y);
	ResetMouse();
}

void Camera::Rotate(Vector3 vPos)
{
	Vector3 vMouseDiff = (m_vMousePos - vPos) * 0.001f;
	m_vCamAngle += vMouseDiff;
}

void Camera::Move(Vector3 vPos)
{
	
}

void Camera::Look()
{
	gRenderer->LookAt(m_transform.position, m_transform.position + m_transform.forward, m_transform.up);
	
}

void Camera::ResetMouse()
{
	if (gPlatform->GetTouchPoints().size() > 0)
	{
		m_vMousePos = gPlatform->GetTouchPoints()[0];
	}
	else
	{
		m_vMousePos = gPlatform->GetMousePos();
	}
}