#pragma once

#include <memory>
#include "cmMath.h"
#include "CollisionType.h"

class Entity : public std::enable_shared_from_this<Entity>
{
public:

	// Not everything needs an id
	Entity(int m_nId = 0);
	virtual ~Entity();

	virtual void Init() {}
	virtual void PreUpdate() {}
	virtual void Update() {}
	virtual void Render() {}
	virtual void OnCollision(Entity* pEntity) {}

	int m_nId;
	cmTransform m_transform;
	CollisionType* m_collision;
	Vector3 m_velocity;
};

