
template <typename T, typename... Args>
T* EntityManager::SpawnEntity(Args... args)
{
	int nId = GetNextEntityId();
	std::shared_ptr<T> entity = std::make_shared<T>(args...);
	entity->m_nId = nId;

	AddEntity(entity);

	//Fire an event of some kind? if needed

	return entity.get();
}

template <typename T>
void EntityManager::GetEntites(std::vector<T*>& entities)
{
	for (const auto& pair : m_entities)
	{
		T* pT = dynamic_cast<T*>(pair.second.get());
		if (pT)
		{
			entities.push_back(pT);
		}
	}
}
