#pragma once
#include "Hazard.h"
#include <string>
class FlameHazard : public Hazard
{
public:

	static const float fMinFlameFrequencyMS;
	static const float fMaxFlameFrequencyMS;
	static const float fMinFlameBurstTimeMS;
	static const float fMaxFlameBurstTimeMS;
	static RNG ms_RNG;

	FlameHazard(cmTransform& transform, const std::string& sTriggerName);
	virtual ~FlameHazard();

	virtual void Update() override;
	virtual void Render() override;
	virtual void OnCollision(Entity* pEntity) override;

	float m_fFlameTimer = 0.0f;
	float m_fFlameFrequencyMS;
	float m_fFlameBurstMS;

	void SetFlames(bool bFlames);
	bool m_bFlamesOn;
	float m_fAnimationTimer;
	float m_fAnimationTime;
};

