#include "GameStateManager.h"
#include "SplashScreenState.h"
#include "MainMenuState.h"
#include "cmMath.h"

GameStateManager::GameStateManager()
{
	PushGameState<MainMenuState>();
}

GameStateManager::~GameStateManager()
{
}

void GameStateManager::Update()
{
	if (m_pCurrentState)
	{
		m_pCurrentState->Update();
	}
}

void GameStateManager::Render()
{
	if (m_pCurrentState)
	{
		m_pCurrentState->Render();
	}
}

bool GameStateManager::OnMouseMove(const Vector3& vMousePos)
{
	if (m_pCurrentState)
	{
		return m_pCurrentState->OnMouseMove(vMousePos);
	}
	return false;
}

bool GameStateManager::OnMouseClick(const cmMouseButtons& button, const Vector3& vPos)
{
	if (m_pCurrentState)
	{
		return m_pCurrentState->OnMouseClick(button, vPos);
	}
	return false;
}

bool GameStateManager::OnMouseDown(const cmMouseButtons& button, const Vector3& vPos)
{
	if (m_pCurrentState)
	{
		return m_pCurrentState->OnMouseDown(button, vPos);
	}
	return false;
}

bool GameStateManager::OnMouseUp(const cmMouseButtons& button, const Vector3& vPos)
{
	if (m_pCurrentState)
	{
		return m_pCurrentState->OnMouseUp(button, vPos);
	}
	return false;
}

bool GameStateManager::OnTouchStart()
{
	if (m_pCurrentState)
	{
		return m_pCurrentState->OnTouchStart();
	}
	return false;
}

bool GameStateManager::OnTouchEnd()
{
	if (m_pCurrentState)
	{
		return m_pCurrentState->OnTouchEnd();
	}
	return false;
}
