#include "InGameScreen.h"
#include "GGJ2015.h"
#include "PlayState.h"

//====================================================================
const wchar_t* InGameScreen::ms_szScreenName = L"InGameScreen";
//====================================================================
InGameScreen::InGameScreen()
{
}

InGameScreen::~InGameScreen()
{
}

void InGameScreen::OnInit()
{
// 	m_pTopBar = new cmGUIImage();
// 	if (m_pTopBar)
// 	{
// 		m_pTopBar->SetPosition(Vector3(0.0f, 0.0f));
// 		m_pTopBar->SetSize(Vector3(1.0f, 0.07f));
// 		m_pTopBar->SetAnchorParent(AnchorTopLeft);
// 		m_pTopBar->SetTexture(L"misc_fillrect.tga");
// 		m_pTopBar->SetAnchorSelf(AnchorTopLeft);
// 		AddComponent(m_pTopBar);
// 
// 		cmGUIImage* pVignette = new cmGUIImage();
// 		if (pVignette)
// 		{
// 			pVignette->SetPosition(Vector3(0.0f, 0.0f));
// 			pVignette->SetSize(Vector3(1.0f, 1.0f));
// 			pVignette->SetAnchorParent(AnchorTopLeft);
// 			pVignette->SetTexture(L"misc_subtle_gradient.tga");
// 			pVignette->SetAnchorSelf(AnchorTopLeft);
// 			m_pTopBar->AddChild(pVignette);
// 		}
// 		
// 		m_pPauseButton = new cmGUIButton();
// 		if (m_pPauseButton)
// 		{
// 			//m_pPauseButton->SetText("II");
// 			m_pPauseButton->SetPosition(Vector3(0.3f, 0.15f));
// 			m_pPauseButton->SetScaleMode(ModeScaledRelativeToHeightAspect);
// 			m_pPauseButton->SetSize(Vector3(1.0f, 1.4f));
// 			m_pPauseButton->SetTextureOff(L"btn_pause.tga");
// 			m_pPauseButton->SetColor(cmColor(1.0f, 1.0f, 1.0f, 1.0f));
// 			m_pPauseButton->SetAnchorParent(AnchorTopLeft);
// 			m_pPauseButton->SetAnchorSelf(AnchorTopLeft);
// 			m_pTopBar->AddChild(m_pPauseButton);
// 		}
// 	}

	InitStageBar();
	
	m_pCurrentTurnImage = new cmGUIImage();
}

void InGameScreen::OnUpdate()
{
	cmColor playerColor = GGJ2015::Get()->GetCurrentPlayerColour();
	if (m_pTopBar)
	{
		m_pTopBar->SetTextureColor(playerColor);
	}

	if (m_pCurrentTurnImage)
	{
		m_pCurrentTurnImage->SetTextureColor(playerColor);
	}


	if (m_pImgTurn)
	{
		if (GGJ2015::Get()->m_playerTurn == Player::Blue)
		{
			m_pImgTurn->SetTexture(L"turn_indicator_blue001.tga");
		}
		else
		{
			m_pImgTurn->SetTexture(L"turn_indicator_red001.tga");
		}
	}


	PlayState* pPlayState = dynamic_cast<PlayState*>(GGJ2015::Get()->GetGameStateManager()->GetCurrentState());
	if (!pPlayState)
		return;

	int currentStage = (int)pPlayState->m_currentStage;

	UpdateStageBar(currentStage);

}


void InGameScreen::TrackSpaceman(Spaceman* pSpaceman)
{
	m_pTrackingSpaceman = pSpaceman;
	
}

void InGameScreen::InitStageBar()
{
	m_pImgTurn = new cmGUIImage();
	if (m_pImgTurn)
	{
		m_pImgTurn->SetSize(Vector3(1.0f, 0.4f));
		m_pImgTurn->SetPosition(Vector3(0.0f, -0.1f));
		m_pImgTurn->SetAnchorParent(AnchorTop);
		m_pImgTurn->SetAnchorSelf(AnchorTop);
		m_pImgTurn->SetScaleMode(ModeScaledRelativeToHeightAspect);
		m_pImgTurn->SetTexture(L"turn_indicator_blue001.tga");
		AddComponent(m_pImgTurn);
	}

	m_pStageBar = new cmGUIImage();
	if (m_pStageBar)
	{
		m_pStageBar->SetSize(Vector3(1.0f, 0.1f));
		m_pStageBar->SetAnchorParent(AnchorBottom);
		m_pStageBar->SetAnchorSelf(AnchorBottom);
		m_pStageBar->SetScaleMode(ModeScaledRelativeToHeightAspect);
		m_pStageBar->SetTexture(L"stage_condition_bg.tga");

		// Objective markers
		cmGUIImage* pRedObj = new cmGUIImage();
		if (pRedObj)
		{
			pRedObj->SetAnchorParent(AnchorRight);
			pRedObj->SetAnchorSelf(AnchorLeft);
			pRedObj->SetScaleMode(ModeScaledRelativeToHeightAspect);
			pRedObj->SetSize(Vector3(1.0f, 1.0f));
			pRedObj->SetTexture(L"stage_condition_objective_red.tga");

			m_pStageBar->AddChild(pRedObj);
		}

		cmGUIImage* pBlueObj = new cmGUIImage();
		if (pBlueObj)
		{
			pBlueObj->SetAnchorParent(AnchorLeft);
			pBlueObj->SetAnchorSelf(AnchorRight);
			pBlueObj->SetScaleMode(ModeScaledRelativeToHeightAspect);
			pBlueObj->SetSize(Vector3(1.0f, 1.0f));
			pBlueObj->SetTexture(L"stage_condition_objective_blue.tga");
			
			m_pStageBar->AddChild(pBlueObj);
		}

		// Segments
		float Segments = (float)Stage::Num_Stages;
		float halfSegments = (1.0f/(float)Stage::Num_Stages)*0.5f;
		for (int i = 0; i < (int)Stage::Num_Stages; ++i)
		{
			m_pStageImages[i] = new cmGUIImage();
			m_pStageImages[i]->SetAnchorParent(AnchorLeft);
			m_pStageImages[i]->SetAnchorSelf(AnchorCenter);
			m_pStageImages[i]->SetPosition(Vector3(((float)i) / Segments + halfSegments, 0.0f));
			m_pStageImages[i]->SetSize(Vector3(1.0f / Segments, 1.0f));

			m_pStageBar->AddChild(m_pStageImages[i]);
		}

		AddComponent(m_pStageBar);
	}

	UpdateStageBar((int) Stage::Stage_Start);
}

void InGameScreen::UpdateStageBar(int currentStage)
{
	

	for (int i = (int)Stage::Stage_Blue2; i <= (int)Stage::Stage_Red2; ++i)
	{
		if (i == currentStage)
		{
			// contested
			m_pStageImages[i]->SetTexture(L"stage_condition_capsule_contest.tga");
			
		}
		else if (i < currentStage)
		{
			// red
			m_pStageImages[i]->SetTexture(L"stage_condition_capsule_red.tga");
		}
		else
		{
			// blue
			m_pStageImages[i]->SetTexture(L"stage_condition_capsule_blue.tga");
		}
	}
	
	m_pStageImages[(int)Stage::Stage_BlueWin]->SetTexture((currentStage == (int)Stage::Stage_BlueWin)
		? L"stage_condition_circle_blue.tga"
		: L"stage_condition_circle_red.tga");

	m_pStageImages[(int)Stage::Stage_RedWin]->SetTexture((currentStage == (int)Stage::Stage_RedWin)
		? L"stage_condition_circle_red.tga"
		: L"stage_condition_circle_blue.tga");
}