#pragma once

#include "cmScreen.h"
#include "cmGUI.h"

#include "Stages.h"

class Spaceman;
class InGameScreen : public  cmScreen
{
public:
	static const wchar_t* ms_szScreenName;

	InGameScreen();
	virtual ~InGameScreen();

	virtual void OnInit();
	virtual void OnUpdate();
	
	cmGUIButton* m_pPauseButton = nullptr;
	cmGUIImage* m_pTopBar = nullptr;
	cmGUIImage* m_pCurrentTurnImage = nullptr;
	cmGUIImage* m_pGameStateImage = nullptr;

	// the spaceman ui
	void TrackSpaceman(Spaceman* pSpaceman);
	Spaceman* m_pTrackingSpaceman;

	// Stage bar
	void InitStageBar();
	void UpdateStageBar(int nStage);
	cmGUIImage* m_pStageBar;
	cmGUIImage* m_pStageImages[(int)Stage::Num_Stages];


	cmGUIImage* m_pImgTurn = nullptr;
	


	// Win screen
	void InitWinScreen();
	cmGUIImage* m_pWinOverlay = nullptr;
	cmGUIImage* m_pTeamWinImg = nullptr;
	cmGUIButton* m_pReplayButton = nullptr;
	cmGUIButton* m_pQuitButton = nullptr;

};

