#pragma once
#include "Entity.h"
#include <string>
#include "Player.h"
class Spaceman : public Entity
{
public:

	enum ePunchDirection
	{
		None,
		TopRight,
		TopLeft,
		BottomRight,
		BottomLeft
	};

	static const float ms_passiveRotationSpeed;
	static const float ms_bounceRotationSpeed;
	static const float ms_rotationDecay;
	static const float ms_sphereRadius;
	static const float ms_punchRadius;
	static const float ms_punchPower;
	static const float ms_bouncinessWall;
	static const float ms_bouncinessSpacemen;
	static const float ms_airFriction;
	static const float ms_maximumLaunchVelocity;
	static const float ms_fHeightSmoothFactor;
	static const float ms_fPunchTime;

	Spaceman(Player player = Player::Blue, float x = 0.0f, float y = 0.0f);
	virtual ~Spaceman();

	// Spacemanny things things
	virtual void PreUpdate();
	virtual void Update();
	virtual void Render();
	virtual void OnCollision(Entity* pEntity);

	Vector3& GetResultantVelocity() { return m_resultantVelocity; }
	void Launch(const Vector3& direction, float fPower);
	void Punch(ePunchDirection dir);
	// vars
	std::wstring m_fullname;
	std::wstring m_tidbit;
	
	ePunchDirection m_ePunchDirection;
	float m_fPunchTimer;

	bool m_bIsColliding;
	float m_fRotationAmount;
	RNG m_rng;
	Vector3 m_resultantVelocity;
	Vector3 m_resultantPosition;
	Player m_player = Player::Blue;

	float m_fNoClipTimer = 0.0f;
};

