#include "SpawnChute.h"
#include "Spaceman.h"
#include "GGJ2015.h"

const float SpawnChute::ms_LaunchVelocity = 0.005f;
const float SpawnChute::ms_fCollisionDisableTimeMS = 1500.0f; // 1.2 second

SpawnChute::SpawnChute(const std::string& locator)
{
	m_transform	= cmLocatorManager::Get().GetLocator(locator);
}

SpawnChute::~SpawnChute()
{
}

Spaceman* SpawnChute::SpawnSpaceman(Player player)
{
	Spaceman* pSpaceman = GGJ2015::Get()->GetEntityManager()->SpawnEntity<Spaceman>();
	pSpaceman->m_transform = m_transform;
	if (pSpaceman)
	{
		pSpaceman->m_player = player;
		pSpaceman->m_fNoClipTimer += ms_fCollisionDisableTimeMS;
		pSpaceman->m_velocity = (m_transform.forward * ms_LaunchVelocity);
		pSpaceman->m_velocity.z = 0.0f;
	}

	return pSpaceman;
}
